# ESLint configuration - Angular

**The Angular extension for our [ESLint configuration base][base-config].**

## Dependencies

- [@pxlwidgets/eslint-config][base-config]
- [@angular-eslint/eslint-plugin](https://www.npmjs.com/package/@angular-eslint/eslint-plugin)
- [@angular-eslint/eslint-plugin-template](https://www.npmjs.com/package/@angular-eslint/eslint-plugin-template)

> Note: This configuration was migrated from [another repository][old-repo] and was previously published
> as a special configuration under `@pxlwidgets/eslint-config`.

## Installation

**npm<v7 or Yarn v1**

On npm versions prior to 7, or when using Yarn V1, you'll have to install both `eslint` and this package, as these
package managers do not automatically install peer dependencies:

```bash
# npm:
npm install --save-dev eslint @pxlwidgets/eslint-config-angular
# yarn:
yarn add    --dev      eslint @pxlwidgets/eslint-config-angular
```

> For the best compatibility, remove the direct `eslint` dependency when your project
> moves to npm >= 7, see below.

**npm >= 7 (node >= 15)**

As of npm v7, peer dependencies are automatically installed, so only installing this package suffices:

```bash
npm install --save-dev @pxlwidgets/eslint-config-angular
```

## Usage

> _Todo: improve docs. This was copied from the previous README._

Angular uses the `ng lint` command. In order to make that command use ESLint instead of TSLint,
follow [this guide](https://github.com/angular-eslint/angular-eslint#migrating-an-angular-cli-project-from-codelyzer-and-tslint)
, or manually perform these steps:

1. Run `ng add @angular-eslint/schematics`
2. Update the `projects` > `app` > `architect` > `lint` property `angular.json` to:

```json
   {
    "lint": {
        "builder": "@angular-eslint/builder:lint",
        "options": {
            "lintFilePatterns": [
                "src/**/*.ts",
                "src/**/*.html"
            ]
        }
    }
}
```

Note that the angular-eslint package will only work for Angular 8+. There is also a separate configuration for E2E in
the `angular.json` if you are using Angular's default E2E testing you may need to make sure that the linting config for
it is set up similarly to the main build.

[base-config]: https://www.npmjs.com/package/@pxlwidgets/eslint-config
[old-repo]: https://gitlab.pxlwidgets.com/internal/documentation/pxl.widgets-ts-style-standard
